package _VisualDVM.Passes.Server;
import Common.Database.Objects.DBObject;
import Common.Utils.Pair;
import _VisualDVM.Repository.Server.RepositoryServer;
import _VisualDVM.Repository.Server.SafeServerExchangeUnit;
import _VisualDVM.Repository.Server.ServerCode;
import _VisualDVM.ServerObjectsCache.VisualCaches;
public class DeleteServerObject<S extends RepositoryServer, D extends DBObject> extends ServerObjectPass<S, D> {
    public DeleteServerObject(S server_in, Class<D> d_in) {
        super(server_in, d_in);
    }
    @Override
    public String getIconPath() {
        return "/Common/icons/Delete.png";
    }
    public String getDescription_() {
        return "удаление";
    }
    @Override
    protected boolean canStart(Object... args) throws Exception {
        target = (D) getDb().getTable(d).getUI().getCurrent();
        return getDb().getTable(d).getUI().CheckCurrent(Log) && getDb().getTable(d).getUI().ShowDeleteObjectDialog(target);
    }
    //Очищаем все связанные таблицы, чтобы не допустить перерисовки во время удаления объекта.
    @Override
    protected void showPreparation() throws Exception {
        getDb().getTable(d).ClearUI();
        for (Class dep : getDb().getTable(d).getFKDependencies().keySet()) {
            switch (getDb().getTable(d).getFKDependencies().get(dep).data) {
                case NONE:
                case DROP:
                    break;
                case DELETE:
                    getDb().getTable(dep).ClearUI();
                    break;
            }
        }
    }
    @Override
    protected void ServerAction() throws Exception {
        Command(new SafeServerExchangeUnit(ServerCode.DeleteObjectByPK, getDBName(),
                new Pair<>(target.getClass(), target.getPK())));
        VisualCaches.DeleteCache(target);
    }
    @Override
    protected void showDone() throws Exception {
        getDb().getTable(d).getUI().Show();
    }
}
